import { game } from "../game";
import { publicUserData, userData } from "./userData";
import { users } from "./users";

export function registerAccountCallbacks(socket){
    function emitLogin(result : userData, registered:boolean = false){
        socket.emit("account/login", JSON.stringify(new publicUserData(result, socket.id)));
        console.log(result)
        if(result != null){
            if(registered){
                console.log(`User ${(result as userData).Login} registerd and logged in`);
            }
            else{
                console.log(`User ${(result as userData).Login} logged in`);
            }
        }
    }
    
    socket.on('account/register', (data) => {
        let buff = Buffer.from(data, 'base64');
        let json = JSON.parse(buff.toString('utf-8'));
        let result = users.createUser(json.Login, json.Password);

        emitLogin(result, true);
    });

    socket.on('account/login', (data) => {
        let buff = Buffer.from(data, 'base64');
        let json = JSON.parse(buff.toString('utf-8'));
        let result = users.readUser(json.Login, json.Password);

        emitLogin(result);
    });
}